#include <iostream>

using namespace std;

int main()
{
   int t;
   cin >> t;
   int ispisi[t];
   for (int z=0; z<t; z++)
   {
       int ispis;
       int n;
       cin >> n;
       int prviniz[n];
       int druginiz[n];
       int suma1=0;
       int suma2=0;
       int da1=1;
       int da2=1;

       for (int i=0; i<n; i++)
       {
           cin >> prviniz[i];
           if (prviniz[i]!=0)
           {
               suma1++;
           }
           if (prviniz[i]!=1 && prviniz[i]!=-1)
           {
               da1=0;
           }
       }
       for (int i=0; i<n; i++)
       {
           cin >> druginiz[i];
           if (druginiz[i]!=0)
           {
               suma2++;
           }
           if (druginiz[i]!=1 && druginiz[i]!=-1)
           {
               da2=0;
           }
       }

       if (suma1==1 && suma2==1)
       {
           int broj1;
           int broj2;
           int mesto1;
           int mesto2;
           for (int i=0; i<n; i++)
           {
               if (prviniz[i]!=0)
               {
                   mesto1=i;
                   broj1=prviniz[i];
               }

           }
           for (int i=0; i<n; i++)
           {
               if (druginiz[i]!=0)
               {
                   mesto2=i;
                   broj2=druginiz[i];
               }
           }
           if ((mesto1-mesto2)%2==0 && broj1==broj2)
           {
               ispis=1;
           }
           if ((mesto1-mesto2)%2==0 && broj1==0-broj2)
           {
               ispis=0;
           }
           if ((mesto1-mesto2)%2==1 && broj1==broj2)
           {
               ispis=0;
           }
           if ((mesto1-mesto2)%2==1 && broj1==0-broj2)
           {
               ispis=1;
           }
           if (broj1!=broj2 && broj1!=0-broj2)
           {
               ispis=0;
           }



       }

       if (suma1==n && suma2==n && da1==1 && da2==1)
       {
           int neg1;
           int neg2;
           for (int i=0; i<n; i++)
           {
               if (prviniz[i]==-1)
               {
                   neg1++;
               }
               if (druginiz[i]==-1)
               {
                   neg2++;
               }
           }
            if ((neg1-neg2)%2==1)
            {
                ispis=0;
            }
            if ((neg1-neg2)%2==0)
            {
                ispis=1;
            }

       }
       ispisi[z]=ispis;

   }
   for (int i=0; i<t; i++)
   {
       if (ispisi[i]==1)
        {
            cout << "DA" << endl;
        }
       if (ispisi[i]==0)
        {
            cout <<"NE" << endl;
        }
   }

   return 0;
}